Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 9098)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 9124)
@@ -19,5 +19,4 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE wrk_nemo        ! work arrays
-   USE timing          ! Timing
    USE daymod          ! calendar
    USE fldread         ! read input fields
@@ -127,6 +126,4 @@
       !!----------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('sbc_ice_cice')
-      !
       !                                        !----------------------!
       IF( MOD( kt-1, nn_fsbc ) == 0 ) THEN     !  Ice time-step only  !
@@ -148,6 +145,4 @@
       ENDIF                                          ! End sea-ice time step only
       !
-      IF( nn_timing == 1 )  CALL timing_stop('sbc_ice_cice')
-
    END SUBROUTINE sbc_ice_cice
 
@@ -164,6 +159,4 @@
       INTEGER  ::   ji, jj, jl, jk                    ! dummy loop indices
       !!---------------------------------------------------------------------
-
-      IF( nn_timing == 1 )  CALL timing_start('cice_sbc_init')
       !
       CALL wrk_alloc( jpi,jpj, ztmp1, ztmp2 )
@@ -281,6 +274,4 @@
       CALL wrk_dealloc( jpi,jpj, ztmp1, ztmp2 )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('cice_sbc_init')
-      !
    END SUBROUTINE cice_sbc_init
 
@@ -299,6 +290,4 @@
       REAL(wp) ::   zintb, zintn  ! dummy argument
       !!---------------------------------------------------------------------
-
-      IF( nn_timing == 1 )  CALL timing_start('cice_sbc_in')
       !
       CALL wrk_alloc( jpi,jpj, ztmp, zpice )
@@ -507,6 +496,4 @@
       CALL wrk_dealloc( jpi,jpj,ncat, ztmpn )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('cice_sbc_in')
-      !
    END SUBROUTINE cice_sbc_in
 
@@ -523,6 +510,4 @@
       REAL(wp), DIMENSION(:,:), POINTER :: ztmp1, ztmp2
       !!---------------------------------------------------------------------
-
-      IF( nn_timing == 1 )  CALL timing_start('cice_sbc_out')
       !
       CALL wrk_alloc( jpi,jpj, ztmp1, ztmp2 )
@@ -680,6 +665,4 @@
       CALL wrk_dealloc( jpi,jpj, ztmp1, ztmp2 )
       !
-      IF( nn_timing == 1 )  CALL timing_stop('cice_sbc_out')
-      !
    END SUBROUTINE cice_sbc_out
 
@@ -691,11 +674,10 @@
       !! 
       !!
+      !!---------------------------------------------------------------------
       INTEGER, INTENT( in  ) ::   kt   ! ocean time step
-      !!---------------------------------------------------------------------
-
+      !!
       INTEGER  ::   jl                        ! dummy loop index
       INTEGER  ::   ierror
-
-      IF( nn_timing == 1 )  CALL timing_start('cice_sbc_hadgam')
+      !!---------------------------------------------------------------------
       !
       IF( kt == nit000 )  THEN
@@ -722,6 +704,4 @@
       END DO
       !
-      IF( nn_timing == 1 )  CALL timing_stop('cice_sbc_hadgam')
-      !
    END SUBROUTINE cice_sbc_hadgam
 
@@ -732,10 +712,11 @@
       !! ** Purpose: Finalize CICE
       !!---------------------------------------------------------------------
-
+      !
       IF(lwp) WRITE(numout,*)'cice_sbc_final'
-
+      !
       CALL CICE_Finalize
-
+      !
    END SUBROUTINE cice_sbc_final
+
 
    SUBROUTINE cice_sbc_force (kt)
@@ -755,10 +736,8 @@
       !! History :
       !!----------------------------------------------------------------------
-      !! * Modules used
       USE iom
-
-      !! * arguments
-      INTEGER, INTENT( in  ) ::   kt ! ocean time step
-
+      !!
+      INTEGER, INTENT( in  ) ::   kt   ! ocean time step
+      !!
       INTEGER  ::   ierror             ! return error code
       INTEGER  ::   ifpr               ! dummy loop index
@@ -769,5 +748,4 @@
       TYPE(FLD_N) ::   sn_top1, sn_top2, sn_top3, sn_top4, sn_top5
       TYPE(FLD_N) ::   sn_bot1, sn_bot2, sn_bot3, sn_bot4, sn_bot5 
-
       !!
       NAMELIST/namsbc_cice/ cn_dir, sn_snow, sn_rain, sn_sblm,   &