Index: branches/2017/dev_merge_2017/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90
===================================================================
--- branches/2017/dev_merge_2017/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 9124)
+++ branches/2017/dev_merge_2017/NEMOGCM/NEMO/LIM_SRC_3/icestp.F90	(revision 9169)
@@ -281,5 +281,6 @@
       !! ** input   :   Namelist nampar
       !!-------------------------------------------------------------------
-      INTEGER  ::   ios                 ! Local integer output status for namelist read
+      INTEGER  ::   ios                 ! Local integer
+      !!
       NAMELIST/nampar/ jpl, nlay_i, nlay_s, nn_virtual_itd, ln_icedyn, ln_icethd, rn_amax_n, rn_amax_s,  &
          &             cn_icerst_in, cn_icerst_indir, cn_icerst_out, cn_icerst_outdir
@@ -288,26 +289,24 @@
       REWIND( numnam_ice_ref )      ! Namelist nampar in reference namelist : Parameters for ice
       READ  ( numnam_ice_ref, nampar, IOSTAT = ios, ERR = 901)
-901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampar in reference namelist', lwp )
-
+901   IF( ios /= 0 )   CALL ctl_nam ( ios , 'nampar in reference namelist', lwp )
       REWIND( numnam_ice_cfg )      ! Namelist nampar in configuration namelist : Parameters for ice
       READ  ( numnam_ice_cfg, nampar, IOSTAT = ios, ERR = 902 )
-902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'nampar in configuration namelist', lwp )
-      IF(lwm) WRITE ( numoni, nampar )
+902   IF( ios > 0 )   CALL ctl_nam ( ios , 'nampar in configuration namelist', lwp )
+      IF(lwm) WRITE( numoni, nampar )
       !
       IF(lwp) THEN                  ! control print
          WRITE(numout,*)
-         WRITE(numout,*) 'par_init: ice parameters shared among all the routines'
-         WRITE(numout,*) ' ~~~~~~~'
-         WRITE(numout,*) '   Namelist nampar: '
-         WRITE(numout,*) '      number of ice  categories                              jpl    = ', jpl
-         WRITE(numout,*) '      number of ice  layers                                  nlay_i = ', nlay_i
-         WRITE(numout,*) '      number of snow layers                                  nlay_s = ', nlay_s
-         WRITE(numout,*) '      virtual ITD param for jpl=1 (1-3) or not (0)   nn_virtual_itd = ', nn_virtual_itd
-         WRITE(numout,*) '      Ice dynamics       (T) or not (F)                   ln_icedyn = ', ln_icedyn
-         WRITE(numout,*) '      Ice thermodynamics (T) or not (F)                   ln_icethd = ', ln_icethd
-         WRITE(numout,*) '      maximum ice concentration for NH                              = ', rn_amax_n 
-         WRITE(numout,*) '      maximum ice concentration for SH                              = ', rn_amax_s
+         WRITE(numout,*) '   par_init: ice parameters shared among all the routines'
+         WRITE(numout,*) '   ~~~~~~~~'
+         WRITE(numout,*) '      Namelist nampar: '
+         WRITE(numout,*) '         number of ice  categories                           jpl       = ', jpl
+         WRITE(numout,*) '         number of ice  layers                               nlay_i    = ', nlay_i
+         WRITE(numout,*) '         number of snow layers                               nlay_s    = ', nlay_s
+         WRITE(numout,*) '         virtual ITD param for jpl=1 (1-3) or not (0)   nn_virtual_itd = ', nn_virtual_itd
+         WRITE(numout,*) '         Ice dynamics       (T) or not (F)                   ln_icedyn = ', ln_icedyn
+         WRITE(numout,*) '         Ice thermodynamics (T) or not (F)                   ln_icethd = ', ln_icethd
+         WRITE(numout,*) '         maximum ice concentration for NH                              = ', rn_amax_n 
+         WRITE(numout,*) '         maximum ice concentration for SH                              = ', rn_amax_s
       ENDIF
-      !
       !                                        !--- check consistency
       IF ( jpl > 1 .AND. nn_virtual_itd == 1 ) THEN
@@ -323,7 +322,8 @@
       IF( ln_bdy .AND. ln_icediachk )   CALL ctl_warn('par_init: online conservation check does not work with BDY')
       !
-      rdt_ice   = REAL(nn_fsbc) * rdt          !--- sea-ice timestep and inverse
+      rdt_ice   = REAL(nn_fsbc) * rdt          !--- sea-ice timestep and its inverse
       r1_rdtice = 1._wp / rdt_ice
-      IF( lwp ) WRITE(numout,*) '   ice timestep rdt_ice = ', rdt_ice
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) '      ice timestep rdt_ice = nn_fsbc*rdt = ', rdt_ice
       !
       r1_nlay_i = 1._wp / REAL( nlay_i, wp )   !--- inverse of nlay_i and nlay_s
@@ -356,5 +356,5 @@
          h_s_b(:,:,:) = 0._wp
       END WHERE
-      
+      !
       ! ice velocities & total concentration
       at_i_b(:,:)  = SUM( a_i_b(:,:,:), dim=3 )
@@ -412,5 +412,5 @@
       tau_icebfr(:,:)   = 0._wp   ! landfast ice param only (clem: important to keep the init here)
       cnd_ice   (:,:,:) = 0._wp   ! initialisation of the effective conductivity at the top of ice/snow (Jules coupling)
-      
+      !
    END SUBROUTINE diag_set0
 